/*
 * vtable.cc --
 */

#include <iostream>
using std::cout;

class A {
public:
    virtual const char* f() { return "A"; }
    virtual ~A() {}
    int a, b;
};

class B : public A {
public:
    const char* f() { return "B"; }
    ~B() {}
    int c, d;
};

int main(void)
{
    A* a = new A();
    B* b = new B();
    A* p = b;

    cout << a->f() << " "
         << b->f() << " "
         << p->f() << std::endl;

    // Lets smash the vtable pointer programmatically (but this could
    // also be achieved by exploiting buffer overruns or using a format
    // string vulnerability).
    
    *(char **) p = *(char **) a;

    cout << a->f() << " "
         << b->f() << " "
         << p->f() << std::endl;

    delete a;
    delete b;
    return 0;
}
